Gdk::Visual Class Reference

A Gdk::Visual describes a particular video hardware display format. More...

Inheritance diagram for Gdk::Visual:
[legend]
Collaboration diagram for Gdk::Visual:
[legend]

## Public Member Functions

| Visual (Visual&& src) noexcept
Visual& | operator= (Visual&& src) noexcept
| ~Visual () noexceptoverride
GdkVisual* | gobj ()
| Provides access to the underlying C GObject. More...
const GdkVisual* | gobj () const
| Provides access to the underlying C GObject. More...
GdkVisual* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Screen > | get_screen ()
| Gets the screen to which this visual belongs. More...
Glib::RefPtr< const Screen > | get_screen () const
| Gets the screen to which this visual belongs. More...
VisualType | get_visual_type () const
| Returns the type of visual this is (PseudoColor, TrueColor, etc). More...
int | get_depth () const
| Returns the bit depth of this visual. More...
ByteOrder | get_byte_order ()
| Returns the byte order of this visual. More...
int | get_colormap_size () const
| Returns the size of a colormap for this visual. More...
int | get_bits_per_rgb () const
| Returns the number of significant bits per red, green and blue value. More...
void | get_red_pixel_details (guint32& mask, int&shift, int& precision) const
| Obtains values that are needed to calculate red pixel values in TrueColor and DirectColor. More...
void | get_green_pixel_details (guint32& mask, int&shift, int& precision) const
| Obtains values that are needed to calculate green pixel values in TrueColor and DirectColor. More...
void | get_blue_pixel_details (guint32& mask, int&shift, int& precision) const
| Obtains values that are needed to calculate blue pixel values in TrueColor and DirectColor. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions

static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Visual > | get_system ()
| Get the system's default visual for the default GDK screen. More...
static Glib::RefPtr< Visual > | get_best ()
| Get the visual with the most available colors for the default GDK screen. More...
static Glib::RefPtr< Visual > | get_best (int depth)
| Get the best visual with depth depth for the default GDK screen. More...
static Glib::RefPtr< Visual > | get_best (VisualType visual_type)
| Get the best visual of the given visual_type for the default GDK screen. More...
static Glib::RefPtr< Visual > | get_best (int depth, VisualType visual_type)
| Combines get_best_with_depth() and get_best_with_type(). More...
static int | get_best_depth ()
| Get the best available depth for the default GDK screen. More...
static VisualType | get_best_type ()
| Return the best available visual type for the default GDK screen. More...

## Protected Member Functions

| Visual ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexceptoverride
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions

(Note that these are not member functions.)
Glib::RefPtr< Gdk::Visual > | wrap (GdkVisual* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members

Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A Gdk::Visual describes a particular video hardware display format.

It includes information about the number of bits used for each color, the way the bits are translated into an RGB value for display, and the way the bits are stored in memory. For example, a piece of display hardware might support 24-bit color, 16-bit color, or 8-bit color; meaning 24/16/8-bit pixel sizes. For a given pixel size, pixels can be in different formats; for example the "red" element of an RGB pixel may be in the top 8 bits of the pixel, or may be in the lower 4 bits.

Usually you can avoid thinking about visuals in GTK+. Visuals are useful to interpret the contents of a GdkImage, but you should avoid Gdk::Image precisely because its contents depend on the display hardware; use Gdk::Pixbuf instead, for all but the most low-level purposes. Also, anytime you provide a Gdk::Colormap, the visual is implied as part of the colormap (Gdk::Colormap::get_visual()), so you won't have to provide a visual in addition.

There are several standard visuals. The visual returned by get_system() is the system's default visual. get_visual() returns the visual most suited to displaying full-color image data. If you use the calls in Gdk::RGB, you should create your windows using this visual (and the colormap returned by Gdk::Rgb::get_colormap()).

A number of methods are provided for determining the "best" available visual. For the purposes of making this determination, higher bit depths are considered better, and for visuals of the same bit depth, GDK_VISUAL_PSEUDO_COLOR is preferred at 8bpp, otherwise, the visual types are ranked in the order of (highest to lowest) GDK_VISUAL_DIRECT_COLOR, GDK_VISUAL_TRUE_COLOR, GDK_VISUAL_PSEUDO_COLOR, GDK_VISUAL_STATIC_COLOR, GDK_VISUAL_GRAYSCALE, then GDK_VISUAL_STATIC_GRAY.

## Constructor & Destructor Documentation

Gdk::Visual::Visual | ( | Visual&& | src | ) |

noexcept

Gdk::Visual::~Visual | ( |  | ) |

overridenoexcept

Gdk::Visual::Visual | ( |  | ) |

protected

## Member Function Documentation

static Glib::RefPtr<Visual> Gdk::Visual::get_best | ( |  | ) |

static

Get the visual with the most available colors for the default GDK screen.

The return value should not be freed.

Returns
  Best visual.

static Glib::RefPtr<Visual> Gdk::Visual::get_best | ( | int | depth | ) |

static

Get the best visual with depth depth for the default GDK screen.

Color visuals and visuals with mutable colormaps are preferred over grayscale or fixed-colormap visuals. The return value should not be freed. `nullptr` may be returned if no visual supports depth.

Parameters

  depth | A bit depth.

Returns
  Best visual for the given depth.

static Glib::RefPtr<Visual> Gdk::Visual::get_best | ( | VisualType | visual_type | ) |

static

Get the best visual of the given visual_type for the default GDK screen.

Visuals with higher color depths are considered better. The return value should not be freed. `nullptr` may be returned if no visual has type visual_type.

Parameters

  visual_type | A visual type.

Returns
  Best visual of the given type.

static Glib::RefPtr<Visual> Gdk::Visual::get_best | ( | int | depth,
|  | VisualType | visual_type
| ) |  |

static

Combines get_best_with_depth() and get_best_with_type().

Parameters

  depth | A bit depth.
  visual_type | A visual type.

Returns
  Best visual with both depth and visual_type, or `nullptr` if none.

static int Gdk::Visual::get_best_depth | ( |  | ) |

static

Get the best available depth for the default GDK screen.

"Best" means "largest," i.e. 32 preferred over 24 preferred over 8 bits per pixel.

Returns
  Best available depth.

static VisualType Gdk::Visual::get_best_type | ( |  | ) |

static

Return the best available visual type for the default GDK screen.

Returns
  Best visual type.

int Gdk::Visual::get_bits_per_rgb | ( |  | ) | const

Returns the number of significant bits per red, green and blue value.

Since gtkmm 2.22:

Returns
  The number of significant bits per color value for visual.

void Gdk::Visual::get_blue_pixel_details | ( | guint32 & | mask,
|  | int & | shift,
|  | int & | precision
| ) |  | const

Obtains values that are needed to calculate blue pixel values in TrueColor and DirectColor.

The "mask" is the significant bits within the pixel. The "shift" is the number of bits left we must shift a primary for it to be in position (according to the "mask"). Finally, "precision" refers to how much precision the pixel value contains for a particular primary.

Since gtkmm 2.22:

Parameters

  mask | A pointer to a #guint32 to be filled in, or `nullptr`.
  shift | A pointer to a `int` to be filled in, or `nullptr`.
  precision | A pointer to a `int` to be filled in, or `nullptr`.

ByteOrder Gdk::Visual::get_byte_order | ( |  | ) |

Returns the byte order of this visual.

Since gtkmm 2.22:

Returns
  A Gdk::ByteOrder stating the byte order of visual.

int Gdk::Visual::get_colormap_size | ( |  | ) | const

Returns the size of a colormap for this visual.

Since gtkmm 2.22:

Returns
  The size of a colormap that is suitable for visual.

int Gdk::Visual::get_depth | ( |  | ) | const

Returns the bit depth of this visual.

Since gtkmm 2.22:

Returns
  The bit depth of this visual.

void Gdk::Visual::get_green_pixel_details | ( | guint32 & | mask,
|  | int & | shift,
|  | int & | precision
| ) |  | const

Obtains values that are needed to calculate green pixel values in TrueColor and DirectColor.

The "mask" is the significant bits within the pixel. The "shift" is the number of bits left we must shift a primary for it to be in position (according to the "mask"). Finally, "precision" refers to how much precision the pixel value contains for a particular primary.

Since gtkmm 2.22:

Parameters

  mask | A pointer to a #guint32 to be filled in, or `nullptr`.
  shift | A pointer to a `int` to be filled in, or `nullptr`.
  precision | A pointer to a `int` to be filled in, or `nullptr`.

void Gdk::Visual::get_red_pixel_details | ( | guint32 & | mask,
|  | int & | shift,
|  | int & | precision
| ) |  | const

Obtains values that are needed to calculate red pixel values in TrueColor and DirectColor.

The "mask" is the significant bits within the pixel. The "shift" is the number of bits left we must shift a primary for it to be in position (according to the "mask"). Finally, "precision" refers to how much precision the pixel value contains for a particular primary.

Since gtkmm 2.22:

Parameters

  mask | A pointer to a #guint32 to be filled in, or `nullptr`.
  shift | A pointer to a `int` to be filled in, or `nullptr`.
  precision | A pointer to a `int` to be filled in, or `nullptr`.

Glib::RefPtr<Screen> Gdk::Visual::get_screen | ( |  | ) |

Gets the screen to which this visual belongs.

Since gtkmm 2.2:

Returns
  The screen to which this visual belongs.

Glib::RefPtr<const Screen> Gdk::Visual::get_screen | ( |  | ) | const

Gets the screen to which this visual belongs.

Since gtkmm 2.2:

Returns
  The screen to which this visual belongs.

static Glib::RefPtr<Visual> Gdk::Visual::get_system | ( |  | ) |

static

Get the system's default visual for the default GDK screen.

This is the visual for the root window of the display. The return value should not be freed.

Returns
  System visual.

static GType Gdk::Visual::get_type | ( |  | ) |

static

Get the GType for this class, for use with the underlying GObject type system.

VisualType Gdk::Visual::get_visual_type | ( |  | ) | const

Returns the type of visual this is (PseudoColor, TrueColor, etc).

Since gtkmm 2.22:

Returns
  A Gdk::VisualType stating the type of visual.

GdkVisual* Gdk::Visual::gobj | ( |  | ) |

inline

Provides access to the underlying C GObject.

const GdkVisual* Gdk::Visual::gobj | ( |  | ) | const

inline

Provides access to the underlying C GObject.

GdkVisual* Gdk::Visual::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

Visual& Gdk::Visual::operator= | ( | Visual&& | src | ) |

noexcept

## Friends And Related Function Documentation

Glib::RefPtr< Gdk::Visual > wrap | ( | GdkVisual * | object,
|  | bool | take_copy = `false`
| ) |  |

related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gdkmm/visual.h